// H264CE.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "H264CE.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>

//H264İļԼ
#include "h264.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE			g_hInst;				// The current instance
HWND				g_hwndCB;					// The command bar handle

static SHACTIVATEINFO s_sai;

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About			(HWND, UINT, WPARAM, LPARAM);
HWND				CreateRpCommandBar(HWND);

//H264غͱ
//̺߳
DWORD DecodeThread(void *para);
HANDLE hDecodeThread;
DWORD dwThreadID;

//GAPIʾԼӲṹ
GXDisplayProperties g_gxdp;    // GX struct
GXKeyList g_gxkl;              // GX struct
//GAPIʾ
BOOL m_bGapi;
BOOL OpenGAPI(HWND* Wnd);
void Blt(int x,int y,int width,int height,unsigned char* data);
BOOL CloseGAPI();

typedef struct THDP
{
	HWND hWnd;
	TCHAR *File;
}THDP;

/////////////////////////////////////////////////////////////////////////////

//YUV->RGBתԼʾƵĺ
int *Cr_r_tab;
int *Cr_g_tab;
int *Cb_g_tab;
int *Cb_b_tab;
Uint32 *r_2_pix_alloc;
Uint32 *g_2_pix_alloc;
Uint32 *b_2_pix_alloc;
int i;
int CR, CB;
Uint32 Rmask, Gmask, Bmask;
int *colortab;
Uint32 *rgb_2_pix;
unsigned short *rgb565;


//ʾȫֱ
int width,height;

void CreateYUVTable()
{
	colortab = (int *)malloc(4*256*sizeof(int));
	Cr_r_tab = &colortab[0*256];
	Cr_g_tab = &colortab[1*256];
	Cb_g_tab = &colortab[2*256];
	Cb_b_tab = &colortab[3*256];
	rgb_2_pix = (Uint32 *)malloc(3*768*sizeof(Uint32));
	r_2_pix_alloc = &rgb_2_pix[0*768];
	g_2_pix_alloc = &rgb_2_pix[1*768];
	b_2_pix_alloc = &rgb_2_pix[2*768];

	/* Generate the tables for the display surface */
	for (i=0; i<256; i++) {
		/* Gamma correction (luminescence table) and chroma correction
		   would be done here.  See the Berkeley mpeg_play sources.
		*/
		CB = CR = (i-128);
		Cr_r_tab[i] = (int) ( (0.419/0.299) * CR);
		Cr_g_tab[i] = (int) (-(0.299/0.419) * CR);
		Cb_g_tab[i] = (int) (-(0.114/0.331) * CB); 
		Cb_b_tab[i] = (int) ( (0.587/0.331) * CB);
	}

	/* 
	 * Set up entries 0-255 in rgb-to-pixel value tables.
	 */
	Rmask = 0xF800;//display->format->Rmask;
	Gmask = 0x7E0;//display->format->Gmask;
	Bmask = 0x1F;//display->format->Bmask;
	for ( i=0; i<256; ++i ) {
		r_2_pix_alloc[i+256] = i >> (8 - 5);
		r_2_pix_alloc[i+256] <<= 0;
		g_2_pix_alloc[i+256] = i >> (8 - 6);
		g_2_pix_alloc[i+256] <<= 5;
		b_2_pix_alloc[i+256] = i >> (8 - 5);
		b_2_pix_alloc[i+256] <<= 11;
	}

	/*
	* If we have 16-bit output depth, then we double the value
	* in the top word. This means that we can write out both
	* pixels in the pixel doubling mode with one op. It is 
	* harmless in the normal case as storing a 32-bit value
	* through a short pointer will lose the top bits anyway.
	*/

	for ( i=0; i<256; ++i ) {
		r_2_pix_alloc[i+256] |= (r_2_pix_alloc[i+256]) << 16;
		g_2_pix_alloc[i+256] |= (g_2_pix_alloc[i+256]) << 16;
		b_2_pix_alloc[i+256] |= (b_2_pix_alloc[i+256]) << 16;
	}

	rgb565=(unsigned short *)malloc(320*240*2);
	
}

void FreeYUVTable()
{
	free(colortab);
	free(rgb_2_pix);
	free(rgb565);
}

static void DisplayYUV( int *colortab, Uint32 *rgb_2_pix,
                                    unsigned char *lum, unsigned char *cr,
                                    unsigned char *cb, unsigned short *out,
                                    int rows, int cols, int mod )
{
    unsigned short* row1;
    unsigned short* row2;
    unsigned char* lum2;
    int x, y;
    int cr_r;
    int crb_g;
    int cb_b;
    int cols_2 = cols / 2;

    row1 = (unsigned short*)rgb565;
    row2 = row1 + cols + mod;
    lum2 = lum + cols;

    mod += cols + mod;

    y = rows / 2;
    while( y-- )
    {
        x = cols_2;
        while( x-- )
        {
            register int L;

            cr_r   = 0*768+256 + colortab[ *cr + 0*256 ];
            crb_g  = 1*768+256 + colortab[ *cr + 1*256 ]
                               + colortab[ *cb + 2*256 ];
            cb_b   = 2*768+256 + colortab[ *cb + 3*256 ];
            ++cr; ++cb;

            L = *lum++;
            *row1++ = (unsigned short)(rgb_2_pix[ L + cr_r ] |
                                       rgb_2_pix[ L + crb_g ] |
                                       rgb_2_pix[ L + cb_b ]);

            L = *lum++;
            *row1++ = (unsigned short)(rgb_2_pix[ L + cr_r ] |
                                       rgb_2_pix[ L + crb_g ] |
                                       rgb_2_pix[ L + cb_b ]);


            /* Now, do second row.  */

            L = *lum2++;
            *row2++ = (unsigned short)(rgb_2_pix[ L + cr_r ] |
                                       rgb_2_pix[ L + crb_g ] |
                                       rgb_2_pix[ L + cb_b ]);

            L = *lum2++;
            *row2++ = (unsigned short)(rgb_2_pix[ L + cr_r ] |
                                       rgb_2_pix[ L + crb_g ] |
                                       rgb_2_pix[ L + cb_b ]);
        }

        /*
         * These values are at the start of the next line, (due
         * to the ++'s above),but they need to be at the start
         * of the line after that.
         */
        lum  += cols;
        lum2 += cols;
        row1 += mod;
        row2 += mod;
    }

	int offset,y1;

	offset=0;

	for(x=0;x<320;x++)
	{
		y1=320;
		for(y=0;y<240;y++)
		{
			out[offset++]=rgb565[y1-x+y];
			y1+=320;
		}		
	}
}


//H.264ȫֱ
AVCodec *codec;			  // Codec
AVCodecContext *c;		  // Codec Context
AVFrame *picture;		  // Frame	
AVFrame *displaypicture;		  // Frame

//ȡļȫֱ
#define DATA_MAX 600000

enum
{
  PARSE_STATE_INIT=0,
  PARSE_STATE_A,
  PARSE_STATE_B
};

//
BOOL m_bDecoding;

BOOL OpenGAPI(HWND *Wnd)
{
	//GAPIʾ
	if(GXOpenDisplay(*Wnd,GX_FULLSCREEN)==0) 
	{
		return FALSE;   //޷GAPIͼ
	}
	else
	{
		//ȡʾ
		g_gxdp = GXGetDisplayProperties();
	}
	return TRUE;
}

BOOL CloseGAPI()
{
	return GXCloseDisplay();
}

//ʾı
HANDLE hDisplayThread=NULL;
DWORD dwDisplayThreadID=0;
HANDLE hDisplayEvent=NULL;
BOOL bDisplay=FALSE;

unsigned short * VideoBuffer;
unsigned char *DisplayBuf;

//ʾ߳
DWORD DisplayThread()
{
	int i,p;

	while(bDisplay)
	{
		WaitForSingleObject(hDisplayEvent,1000);
		p=0;
		for(i=0; i<c->height; i++)
		{
			memcpy(DisplayBuf+p,displaypicture->data[0] + i * displaypicture->linesize[0], c->width);
			p+=c->width;
		}
		for(i=0; i<c->height/2; i++)
		{
			memcpy(DisplayBuf+p,displaypicture->data[1] + i * displaypicture->linesize[1], c->width/2);
			p+=c->width/2;
		}
		for(i=0; i<c->height/2; i++)
		{
			memcpy(DisplayBuf+p,displaypicture->data[2] + i * displaypicture->linesize[2], c->width/2);
			p+=c->width/2;
		}
		//ʾ
		DisplayYUV(colortab,rgb_2_pix,DisplayBuf,(DisplayBuf+76800),(DisplayBuf+96000),VideoBuffer,240,320,1);

		ResetEvent(hDisplayEvent);
	}

	return 0;
}

//߳
DWORD DecodeThread(void *para)
{
	THDP* threadpara=(THDP*)para;

	FILE * inpf;
	int i,p;
	int  got_picture, consumed_bytes; 	

	int i_data_size, i_cur, i_nal_start; //buffer correlative
	int b_eof_h264=0;
	int i_read;
	int b_need_buffer=0;
	int i_parse_state, i_start_code_size; //nal extraction correlative
	int b_find_nal;
	int b_decode_finish;

	DisplayBuf=new unsigned char[115200];	

	int i_frames=0;
	int StartTime,EndTime;
	TCHAR fps[20];

	//ȡļ
	char *name;
	name=new char [wcslen(threadpara->File)];
	
	//ת
	int actuallength=0;	
	actuallength=WideCharToMultiByte(CP_ACP,NULL,(LPCWSTR)threadpara->File,wcslen(threadpara->File),(LPSTR)name,0,NULL,NULL);	
	delete name;
	
	name=new char [actuallength];
	ZeroMemory(name,actuallength);
	WideCharToMultiByte(CP_ACP,NULL,(LPCWSTR)threadpara->File,wcslen(threadpara->File),(LPSTR)name,actuallength,NULL,NULL);
	
	inpf = fopen(name, "rb");
	LocalFree(threadpara->File);
	delete name;

	if(!inpf)
	{
		goto Decodereturn;
	}

	uint8_t* data=new uint8_t[DATA_MAX];

	avcodec_init(); 
	//avcodec_register_all(); 
	codec = &h264_decoder;//avcodec_find_decoder(CODEC_ID_H264);

	if (!codec)  {
		goto Decodereturn;
	} 
		//allocate codec context
    c = avcodec_alloc_context(); 

	if(!c){
		goto Decodereturn;
	}
	//open codec
    if (avcodec_open(c, codec) < 0) {
		goto Decodereturn;
	} 
	
	//allocate frame buffer
    picture   = avcodec_alloc_frame();
	if(!picture){
		goto Decodereturn;
	}

	displaypicture   = avcodec_alloc_frame();
	if(!displaypicture){
		goto Decodereturn;
	}

	VideoBuffer=(unsigned short *)GXBeginDraw();

	//ʾ߳
	hDisplayEvent=CreateEvent(NULL,TRUE,FALSE,NULL);
	bDisplay=TRUE;
	hDisplayThread=CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)DisplayThread,NULL,0,&dwDisplayThreadID);

	StartTime=GetTickCount();

	//confirm the first start code
	i_read=fread(&data[0],1,DATA_MAX,inpf);
	if(i_read < 4)
	{
		fprintf(stderr,"the h264 stream file is too small, even can't include the first start code\n");
		goto Decodereturn;
	}
	i_data_size=i_read;
	if(data[0]!=0x00 || data[1]!=0x00 || data[2]!=0x00 || data[3]!=0x01 )
	{
		fprintf(stderr,"confirm the first start code failed\n");
		goto Decodereturn;
	}
	i_cur=4;
	i_nal_start=4;
	b_need_buffer=0;
	b_decode_finish=0;
	//[2] main loop
	while (!b_decode_finish && m_bDecoding)
	{
		//[2.1] fill buffer
		if (b_need_buffer)
		{
			//transfer the partly read nal data to the top of the buffer
			//note: here, i_data_size must equal with i_cur
			i_data_size=i_cur-i_nal_start; 
			memmove(&data[0],&data[i_nal_start],i_data_size); //overlap is possible
			i_nal_start=0;
			i_cur=i_data_size;

			//read more data
			i_read=fread(&data[i_data_size],1,DATA_MAX-i_data_size,inpf);
			if (i_read<=0)
			{
				b_eof_h264=1;
			}
			else
			{
				i_data_size+=i_read;
			}

			b_need_buffer=0;//!!
		}
		else
		{
			i_parse_state=PARSE_STATE_INIT;
		}

		//[2.2] extract a nal
		b_find_nal=0;
		while (i_cur<i_data_size && !b_find_nal)
		{
			switch(i_parse_state) 
			{
			case PARSE_STATE_INIT:
				if (0==data[i_cur])
					i_parse_state=PARSE_STATE_A;
				else
					i_parse_state=PARSE_STATE_INIT;
				break;
			case PARSE_STATE_A:
				if (0==data[i_cur])
				{
					i_start_code_size=2;
					i_parse_state=PARSE_STATE_B;
				}
				else
					i_parse_state=PARSE_STATE_INIT;
				break;
			case PARSE_STATE_B:
				if (0==data[i_cur])
				{
					i_start_code_size++;
					i_parse_state=PARSE_STATE_B;
				}
				else if (1==data[i_cur])
				{
					i_start_code_size++;
					b_find_nal=1;
				}
				else
				{
					i_parse_state=PARSE_STATE_INIT;
				}
				break;
			default: 
				//can't jump here
				break;
			}
			i_cur++;//!!
		}//end of while (i_cur<i_data_size && !b_find_nal)

		//when we haven't found a nal...
		if (!b_find_nal && !b_eof_h264)
		{
			b_need_buffer=1;
			continue;
		}

		//judge decode finish
		if (i_cur>=i_data_size)
		{
			if (b_eof_h264)
			{
				i_start_code_size=0;//for it is the last nal //lsp!!!!
				b_decode_finish=1;
			}
			else
			{
				b_need_buffer=1; //the buffer is extractly used over
			}
		}

		__try
		{
			consumed_bytes= avcodec_decode_video(c, picture, &got_picture, &data[i_nal_start-i_start_code_size], i_cur-i_nal_start);
			//DEBUGMSG(1,(L"data:%d length:%d\r\n",data[i_nal_start-i_start_code_size+4],i_cur-i_nal_start));
			i_nal_start=i_cur;
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
		}

		if(consumed_bytes > 0)
		{	
			/*
			p=0;
			for(i=0; i<c->height; i++)
			{
				memcpy(DisplayBuf+p,picture->data[0] + i * picture->linesize[0], c->width);
				p+=c->width;
			}
			for(i=0; i<c->height/2; i++)
			{
				memcpy(DisplayBuf+p,picture->data[1] + i * picture->linesize[1], c->width/2);
				p+=c->width/2;
			}
			for(i=0; i<c->height/2; i++)
			{
				memcpy(DisplayBuf+p,picture->data[2] + i * picture->linesize[2], c->width/2);
				p+=c->width/2;
			}
			//ʾ
			DisplayYUV(colortab,rgb_2_pix,DisplayBuf,(DisplayBuf+76800),(DisplayBuf+96000),VideoBuffer,240,320,1);
			*/
			memcpy(displaypicture,picture,sizeof(AVFrame));
			SetEvent(hDisplayEvent);
			i_frames++;
		}

	}//end of while (!b_ctrl_c)

	EndTime=GetTickCount();

Decodereturn:

	//ʾ߳
	bDisplay=FALSE;
	SetEvent(hDisplayEvent);	
	WaitForSingleObject(hDisplayThread,INFINITE);
	CloseHandle(hDisplayEvent);
	CloseHandle(hDisplayThread);


	GXEndDraw(); //ͼһҪ
	CloseGAPI();
	
	if(inpf)
	{
		fclose(inpf);
	}

	if(c) {
		avcodec_close(c); 
		av_free(c);
		c = NULL;
	} 
	if(picture) {
		av_free(picture);
		picture = NULL;
	}
	if(displaypicture)
	{
		av_free(displaypicture);
		displaypicture=NULL;
	}

	delete data;

	delete DisplayBuf;

	wsprintf(fps,L"%f fps",(float)(1000*i_frames)/(float)(EndTime-StartTime));
	MessageBox(NULL,fps,L"H264CE",MB_OK);	

    return 0;
}


int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_H264CE);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    It is important to call this function so that the application 
//    will get 'well formed' small icons associated with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_H264CE));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

//
//  FUNCTION: InitInstance(HANDLE, int)
//
//  PURPOSE: Saves instance handle and creates main window
//
//  COMMENTS:
//
//    In this function, we save the instance handle in a global variable and
//    create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd = NULL;
	TCHAR	szTitle[MAX_LOADSTRING];			// The title bar text
	TCHAR	szWindowClass[MAX_LOADSTRING];		// The window class name

	g_hInst = hInstance;		// Store instance handle in our global variable
	// Initialize global strings
	LoadString(hInstance, IDC_H264CE, szWindowClass, MAX_LOADSTRING);
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);

	//If it is already running, then focus on the window
	hWnd = FindWindow(szWindowClass, szTitle);	
	if (hWnd) 
	{
		// set focus to foremost child window
		// The "| 0x01" is used to bring any owned windows to the foreground and
		// activate them.
		SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
		return 0;
	} 

	MyRegisterClass(hInstance, szWindowClass);
	
	hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
	if (!hWnd)
	{	
		return FALSE;
	}
	//When the main window is created using CW_USEDEFAULT the height of the menubar (if one
	// is created is not taken into account). So we resize the window after creating it
	// if a menubar is present
	if (g_hwndCB)
    {
		RECT rc;
        RECT rcMenuBar;

		GetWindowRect(hWnd, &rc);
        GetWindowRect(g_hwndCB, &rcMenuBar);
		rc.bottom -= (rcMenuBar.bottom - rcMenuBar.top);
		
		MoveWindow(hWnd, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, FALSE);
	}


	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}

// Mesage handler for the open dialog
LRESULT CALLBACK Open(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;
	
	switch (message)
	{
	case WM_INITDIALOG:
		// Create a Done button and size it.  
		shidi.dwMask = SHIDIM_FLAGS;
		shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
		shidi.hDlg = hDlg;
		SHInitDialog(&shidi);
		
		// provide a default file name
		SetDlgItemText(hDlg, IDC_OPENFILE, _T("\\My Documents\\qvga.264"));
		return TRUE; 
		
	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK) 
		{
			// allocate memory for the file name the user typed in
			TCHAR*	pszFileName = NULL;
			pszFileName = (TCHAR*)LocalAlloc(LPTR, MAX_PATH);
			
			if(pszFileName)
			{
				// get the file name
				GetDlgItemText(hDlg, IDC_OPENFILE, pszFileName, MAX_PATH);
				
				// end the dialog passing a pointer to the TCHAR string
				EndDialog(hDlg, (INT)pszFileName);
				
			}
			else
			{
				MessageBox(hDlg, TEXT("޷ΪļƷڴ"), TEXT("򿪴"), MB_OK);
				EndDialog(hDlg, NULL);

			}
			return TRUE;
		}
		if(LOWORD(wParam) == IDC_CANCEL)
		{
			// send null as return value so we know the user clicked cancel
			EndDialog(hDlg, NULL);
			return TRUE;
		}
		
		break;
	}
    return FALSE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	TCHAR szTitle[MAX_LOADSTRING];

	static THDP threadpara;

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{	
				case IDM_HELP_ABOUT:
					DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				    break;
				case IDOK:
					FreeYUVTable();
					SendMessage (hWnd, WM_CLOSE, 0, 0);
					break;
				case IDM_EXIT:
					//еĻֹͣ߳
					if(hDecodeThread)
					{
						TerminateThread(hDecodeThread,0);
						CloseHandle(hDecodeThread);
						hDecodeThread=NULL;
						CloseGAPI();
						m_bGapi=FALSE;
					}
					DestroyWindow(hWnd);
					break;
				case ID_FILE_OPEN:
					{
						//еĻֹͣ߳
						if(hDecodeThread)
						{
							m_bDecoding=FALSE;
							WaitForSingleObject(hDecodeThread,INFINITE);
							CloseHandle(hDecodeThread);
							hDecodeThread=NULL;
							CloseGAPI();
							m_bGapi=FALSE;
						}
						TCHAR*	pszFileToOpen	= NULL;
						// get the name of the file the user wishes to use			
						pszFileToOpen = (TCHAR*)DialogBox(g_hInst, (LPCTSTR)IDD_OPEN, NULL, (DLGPROC)Open);  
						// check to see if we returned null - means the user clicked cancel
						if(pszFileToOpen)
						{
							// check to see if the file name has greater than 0 length
							if(wcslen(pszFileToOpen))
							{
								//ļҲ							
								
								//ʼ߳
								m_bDecoding=TRUE;
								m_bGapi=OpenGAPI(&hWnd);				
								threadpara.hWnd=hWnd;
								threadpara.File=pszFileToOpen;
								hDecodeThread=CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)DecodeThread,(void*)&threadpara,0,&dwThreadID);
							}
						}
					}
					break;
				case ID_TOOL_STOP:
					//еĻֹͣ߳
					if(hDecodeThread)
					{
						m_bDecoding=FALSE;
						WaitForSingleObject(hDecodeThread,INFINITE);
						CloseHandle(hDecodeThread);
						hDecodeThread=NULL;
						CloseGAPI();
						m_bGapi=FALSE;
					}
					break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_CREATE:
			g_hwndCB = CreateRpCommandBar(hWnd);
            // Initialize the shell activate info structure
            memset (&s_sai, 0, sizeof (s_sai));
            s_sai.cbSize = sizeof (s_sai);
			//ʼʾ
			width=IMAGE_WIDTH;height=IMAGE_HEIGHT;

			CreateYUVTable();
			
			m_bDecoding=FALSE;
			hDecodeThread=NULL;
			break;
		case WM_PAINT:
			RECT rt;
			hdc = BeginPaint(hWnd, &ps);
			GetClientRect(hWnd, &rt);
			LoadString(g_hInst, IDS_TITLE, szTitle, MAX_LOADSTRING);
			rt.top=0;
			rt.bottom=20;
			DrawText(hdc, szTitle, _tcslen(szTitle), &rt, 
				DT_SINGLELINE | DT_VCENTER | DT_CENTER);
			EndPaint(hWnd, &ps);
			break; 
		case WM_DESTROY:
			CommandBar_Destroy(g_hwndCB);			
			PostQuitMessage(0);
			break;
		case WM_ACTIVATE:
            // Notify shell of our activate message
			SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
     		break;
		case WM_SETTINGCHANGE:
			SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
     		break;
		case WM_DISPLAY_FRAME:
			unsigned char* DisplayBuf;
			DisplayBuf=(unsigned char*)wParam;	

			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

HWND CreateRpCommandBar(HWND hwnd)
{
	SHMENUBARINFO mbi;

	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = IDM_MENU;
	mbi.hInstRes   = g_hInst;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;

	if (!SHCreateMenuBar(&mbi)) 
		return NULL;

	return mbi.hwndMB;
}

// Mesage handler for the About box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;

	switch (message)
	{
		case WM_INITDIALOG:
			// Create a Done button and size it.  
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
			return TRUE; 

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK)
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
