/*
 * DSP utils
 * Copyright (c) 2000, 2001 Fabrice Bellard.
 * Copyright (c) 2002-2004 Michael Niedermayer <michaelni@gmx.at>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * gmc & q-pel & 32/64 bit based MC by Michael Niedermayer <michaelni@gmx.at>
 */
 
/**
 * @file dsputil.c
 * DSP utils
 */
 
#include "avcodec.h"
#include "dsputil.h"
#include "mpegvideo.h"
//#include "simple_idct.h"
#include <assert.h>
//#include "faandct.h"
#include "windows.h"

extern uint8_t cropTbl[256 + 2 * 384];
extern uint32_t squareTbl[512];



//Problem
void put_h264_qpel8_v_lowpass(uint8_t *dst, uint8_t *src, int dstStride, int srcStride)
{ 
	const int w=8; uint8_t *cm = cropTbl + 384; 
	char i; 
	int srcB; 
	int srcA; 
	int src0;
	int src1;
	//int src[2 *srcStride];
	int src3;
	//int src[4 *srcStride];
	int src5;
	int src6;
	int src7;
	//int src[8 *srcStride];
	int src9;
	int src10;
	for(i=0; i<w; i++) 
	{ 
		srcB= src[-2*srcStride]; 
		srcA= src[-1*srcStride]; 
		src0= src[0 *srcStride]; 
		src1= src[1 *srcStride]; 
		//src[2 *srcStride]= src[2 *srcStride]; 
		src3= src[3 *srcStride]; 
		//src[4 *srcStride]= src[4 *srcStride]; 
		src5= src[5 *srcStride]; 
		src6= src[6 *srcStride]; 
		src7= src[7 *srcStride]; 
		//src[8 *srcStride]= src[8 *srcStride]; 
		src9= src[9 *srcStride]; 
		src10=src[10*srcStride]; 
		
		//DEBUGMSG(1,(L"%3d %3d %3d %3d %3d %3d %3d %3d %3d %3d %3d %3d %3d\r\n",srcB,srcA,src0,src1,src[2 *srcStride],src3,src[4 *srcStride],src5,src6,src7,src[8 *srcStride],src9,src10));

		dst[0*dstStride] = cm[(((src0+src1)*20 - (srcA+src[2 *srcStride])*5 + (srcB+src3)) + 16)>>5]; 
		dst[1*dstStride] = cm[(((src1+src[2 *srcStride])*20 - (src0+src3)*5 + (srcA+src[4 *srcStride])) + 16)>>5]; 
		dst[2*dstStride] = cm[(((src[2 *srcStride]+src3)*20 - (src1+src[4 *srcStride])*5 + (src0+src5)) + 16)>>5]; 
		dst[3*dstStride] = cm[(((src3+src[4 *srcStride])*20 - (src[2 *srcStride]+src5)*5 + (src1+src6)) + 16)>>5]; 
		dst[4*dstStride] = cm[(((src[4 *srcStride]+src5)*20 - (src3+src6)*5 + (src[2 *srcStride]+src7)) + 16)>>5]; 
		dst[5*dstStride] = cm[(((src5+src6)*20 - (src[4 *srcStride]+src7)*5 + (src3+src[8 *srcStride])) + 16)>>5]; 
		dst[6*dstStride] = cm[(((src6+src7)*20 - (src5+src[8 *srcStride])*5 + (src[4 *srcStride]+src9)) + 16)>>5]; 
		dst[7*dstStride] = cm[(((src7+src[8 *srcStride])*20 - (src6+src9)*5 + (src5+src10)) + 16)>>5]; 
		
		dst++; 
		src++; 
	}
}
